## gftl 1.2.5

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)
if (COMMAND cmake_policy)
  cmake_policy (SET CMP0003 NEW)
endif (COMMAND cmake_policy)

project (GFTL
  VERSION 1.2.5
  LANGUAGES Fortran)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set (CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/installed" CACHE PATH "..." FORCE)
  message("-- Setting default install prefix to ${CMAKE_INSTALL_PREFIX}.")
  message("   Override with -DCMAKE_INSTALL_PREFIX=<path>.")
endif ()


add_subdirectory (include)
add_subdirectory (examples)

find_package (PFUNIT 4.1 QUIET)
if (PFUNIT_FOUND)
  message("-- Detecting pFUnit: ${PFUNIT_DIR}")
  project (GFTL-TEST
    VERSION ${GFTL_VERSION}
    LANGUAGES Fortran
    )

  set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${GFTL_SOURCE_DIR}/cmake_utils")
  include (${CMAKE_Fortran_COMPILER_ID} RESULT_VARIABLE found)
  include (CheckFortranSource)
  include (CheckCompilerCapabilities)

  enable_testing()
  if (NOT TARGET tests)
    add_custom_target(tests COMMAND ${CMAKE_CTEST_COMMAND})
  endif ()
  
  add_subdirectory(tests EXCLUDE_FROM_ALL)
endif ()

configure_file(GFTLConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/GFTLConfig.cmake @ONLY)
configure_file(GFTLConfig-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/GFTLConfig-version.cmake @ONLY)

set (top_dir "GFTL-${GFTL_VERSION_MAJOR}.${GFTL_VERSION_MINOR}")
install (
  FILES ${CMAKE_CURRENT_BINARY_DIR}/GFTLConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/GFTLConfig-version.cmake
  DESTINATION "${top_dir}/cmake"
  )

# The following is needed for external projects using *nix make when
# parent project builds gFTL as a subproject.
set (GFTL_TOP_DIR "${CMAKE_INSTALL_PREFIX}/${top_dir}" CACHE PATH "")
configure_file(GFTL.mk.in ${CMAKE_CURRENT_BINARY_DIR}/GFTL.mk @ONLY)
install (
  FILES ${CMAKE_CURRENT_BINARY_DIR}/GFTL.mk 
  DESTINATION "${top_dir}/include"
  )

=== tests/CMakeLists.txt ===

add_subdirectory (shared)
add_subdirectory (Vector)
add_subdirectory (Map)
add_subdirectory (Set)
add_subdirectory (altSet)

# Need to exapnd intrinsic template for various types with m4
add_subdirectory(include) 


include_directories (${PFUNIT}/include)
link_directories (${PFUNIT}/lib)

include_directories (${CMAKE_CURRENT_SOURCE_DIR})
include_directories (${GFTL_SOURCE_DIR}/tests/shared)
include_directories (${GFTL_BINARY_DIR}/tests/shared)

include_directories (${CMAKE_CURRENT_BINARY_DIR}/Set)
include_directories (${CMAKE_CURRENT_BINARY_DIR}/altSet)
include_directories (${CMAKE_CURRENT_BINARY_DIR}/Map)
include_directories (${CMAKE_CURRENT_BINARY_DIR}/Vector)

include_directories (${CMAKE_CURRENT_BINARY_DIR}/altSet/SUT)
include_directories (${CMAKE_CURRENT_BINARY_DIR}/Set/SUT)
include_directories (${CMAKE_CURRENT_BINARY_DIR}/Map/SUT)
include_directories (${CMAKE_CURRENT_BINARY_DIR}/Vector/SUT)

include_directories (${CMAKE_CURRENT_SOURCE_DIR}/altSet)
include_directories (${CMAKE_CURRENT_SOURCE_DIR}/Set)
include_directories (${CMAKE_CURRENT_SOURCE_DIR}/Map)
include_directories (${CMAKE_CURRENT_SOURCE_DIR}/Vector)

#set(driver ${PFUNIT_TOP_DIR}/include/driver.F90)
#add_executable(tests.x EXCLUDE_FROM_ALL ${driver})
#target_link_libraries(tests.x testVector vectorSUT testaltSet altsetSUT testSet setSUT testMap mapSUT shared pfunit)

=== include/templates/CMakeLists.txt ===
set(src ${CMAKE_CURRENT_SOURCE_DIR})
set(bin ${CMAKE_CURRENT_BINARY_DIR})

# Need to create a 2D array of include files.
# First axis is {type,key,value}
set (template_params type key value)

# Second axis is role
set (macro_files
  template_macros
  template_macros_undefs
  testing_macros
  set_use_tokens
  use_tokens_undef
  macros_undefs)

# Empty list - will append in loop below
set(generated_incs)

find_program( m4_found "m4" )
if( NOT m4_found )
  message( SEND_ERROR "m4 program not found" )
endif()

foreach( macro_file ${macro_files} )
  foreach( param ${template_params} )
    set( infile ${src}/${macro_file}.m4 )
    set( outfile ${param}_${macro_file}.inc )
    set (outpath ${CMAKE_CURRENT_BINARY_DIR}/${outfile})

    add_custom_command (
      OUTPUT ${outfile}
      COMMAND m4 -s -Dparam=${param} -I${src}/../templates < ${infile} > ${outfile}
      WORKING_DIRECTORY ${bin}
      DEPENDS ${infile}
      )

      list (APPEND generated_incs ${outfile} )

  endforeach()
endforeach()

add_custom_target(
  generate-template-incs
  DEPENDS ${generated_incs}
  )

add_dependencies (gftl generate-template-incs)

set_source_files_properties (${generated_incs} PROPERTIES GENERATED TRUE)

file (COPY DIRECTORY . DESTINATION . FILES_MATCHING PATTERN "*.inc")

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/ DESTINATION "${dest}/include/templates"
  FILES_MATCHING PATTERN "*.inc"
  PATTERN CMakeFiles EXCLUDE
  )

=== include/types/CMakeLists.txt ===
set(src ${CMAKE_CURRENT_SOURCE_DIR})
set(bin ${CMAKE_CURRENT_BINARY_DIR})

set (template_params type key value)
set (macro_files
  integer
  real
  real32
  real64
  complex
  complex64
  complex128
  logical
  character
  deferredLengthString
  character17
  unlimitedPoly
  unlimitedPolyPtr
  
  integer1d
  integer2d
  integer2d_fixedExtents

  integerPtr
  integer2dPtr
  integerAlloc

  Foo
  FooPtr
  FooPoly
  FooPolyPtr
  )

# Empty list - will append in loop below
set (generated_incs)

foreach (macro_file ${macro_files})
  foreach (param ${template_params})
    set (infile ${src}/${macro_file}.m4)
    if (${param} STREQUAL type)
      set (outfile ${macro_file}.inc)
    else ()
      set (outfile ${param}_${macro_file}.inc)
    endif ()
    set (outpath ${CMAKE_CURRENT_BINARY_DIR}/${outfile})

    add_custom_command (
      OUTPUT ${outfile}
      COMMAND m4 -s -Dparam=${param} -I${src}/../templates < ${infile} > ${outfile}
      WORKING_DIRECTORY ${bin}
      DEPENDS ${infile}
      )

    list (APPEND generated_incs ${outfile} )

  endforeach ()
endforeach ()

add_custom_target (generate-type-incs
  DEPENDS ${generated_incs}
  )
add_dependencies (gftl generate-type-incs)

set_source_files_properties (${generated_incs} PROPERTIES GENERATED TRUE)

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/ DESTINATION "${dest}/include/types"
  FILES_MATCHING PATTERN "*.inc"
  PATTERN CMakeFiles EXCLUDE
  )

=== tests/Map/CMakeLists.txt ===
add_subdirectory(SUT)


include_directories (${PFUNIT_TOP_DIR}/include)
link_directories(${PFUNIT_TOP_DIR}/lib)


set (src ${CMAKE_CURRENT_SOURCE_DIR})
set (bin ${CMAKE_CURRENT_BINARY_DIR})

set  (instantiations
# vary value type
  "integer\;integer"
  "integer\;real"
  "integer\;logical"
  "integer\;complex"
  "integer\;deferredLengthString"
  "integer\;Foo"
  "integer\;FooPoly"
  "integer\;integerAlloc"
  "integer\;integerPtr"
  "integer\;integer1d"
  "integer\;integer2d_fixedExtents"
  "integer\;integer2dPtr"

# vary key type
  "real32\;integer"
  "complex\;integer"
  "deferredLengthString\;integer"
  "Foo\;integer"
  "integerAlloc\;integer"
  "integerPtr\;integer"
  "integer1d\;integer"
  "integer2dPtr\;integer"

# This next one needs custom support in tests.
#  "deferredLengthString\;unlimitedPoly"

# duplicate combos
  "integerPtr\;integerPtr"
  "integer1d\;integer1d"
  "deferredLengthString\;deferredLengthString"
  )

set (infile ${src}/Test_Map.m4)

foreach (instantiation ${instantiations})
  list (GET instantiation 0 key)
  list (GET instantiation 1 value)

  set (pfunitfile Test_${key}${value}Map.pf)

  # Use relative path for outfile so that CMake correctly
  # detects the need to generate include files.

  add_custom_command (
    OUTPUT ${pfunitfile}
    COMMAND m4 -s -DKEY=${key} -DVALUE=${value} -DALT= -Dformat=${format} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )

  list (APPEND SRCS ${CMAKE_CURRENT_BINARY_DIR}/${pfunitfile} )


  set (pfunitfile Test_${key}${value}altMap.pf)

  # Use relative path for outfile so that CMake correctly
  # detects the need to generate include files.

  add_custom_command (
    OUTPUT ${pfunitfile}
    COMMAND m4 -s -DKEY=${key} -DVALUE=${value} -DALT=alt -Dformat=${format} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )

  list (APPEND SRCS ${CMAKE_CURRENT_BINARY_DIR}/${pfunitfile} )

endforeach ()


list (APPEND SRCS
  AuxTest.pf
  Test_map_Allocatable.pf
  Test_map_double_assign.pf)

add_pfunit_ctest (map_tests
  TEST_SOURCES ${SRCS}
  LINK_LIBRARIES mapSUT
  )

target_include_directories (map_tests PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)
target_include_directories (map_tests PRIVATE ${GFTL_SOURCE_DIR}/include)
add_dependencies (tests map_tests)

=== tests/Set/CMakeLists.txt ===
add_subdirectory(SUT)

set (src ${CMAKE_CURRENT_SOURCE_DIR})
set (bin ${CMAKE_CURRENT_BINARY_DIR})

set  (types
  integer
  real
  real64
  complex

  deferredLengthString

  integer1d
  integer2d
  integer2d_fixedExtents

  integerAlloc
  integerPtr
  integer2dPtr

  Foo
  FooPtr
  FooPoly
  FooPolyPtr

  unlimitedPolyPtr

# Unsupportable combinations:
# unlimitedPoly
  )

if (SUPPORTS_POINTERS_TO_FIXED_LENGTH_STRINGS)
  LIST (APPEND types character17)
endif ()

set(SRCS)

foreach (type ${types} )
  set (infile ${src}/Test_Set.m4)
  set (pfunitfile Test_${type}Set.pf)

  # Use relative path for outfile so that CMake correctly
  # detects the need to generate include files.

  add_custom_command (
    OUTPUT ${pfunitfile}
    COMMAND m4 -s -Dparam=${type} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )

  list (APPEND SRCS ${CMAKE_CURRENT_BINARY_DIR}/${pfunitfile} )

endforeach ()


add_pfunit_ctest (set_tests
  TEST_SOURCES ${SRCS}
  LINK_LIBRARIES setSUT
  )

target_include_directories (set_tests PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)
target_include_directories (set_tests PRIVATE ${GFTL_SOURCE_DIR}/include)
add_dependencies (tests set_tests)

=== tests/Vector/CMakeLists.txt ===
add_subdirectory (SUT)

include_directories  (${PFUNIT_TOP_DIR}/include)
link_directories (${PFUNIT_TOP_DIR}/lib)

set (src ${CMAKE_CURRENT_SOURCE_DIR})
set (bin ${CMAKE_CURRENT_BINARY_DIR})

set  (types
  integer
  real
  real64
  complex
  logical
  unlimitedPoly
  unlimitedPolyPtr

  integer1d
  integer2d
  integer2d_fixedExtents

  integerAlloc
  integerPtr
  integer2dPtr

  Foo
  FooPtr
  FooPoly
  FooPolyPtr
  )

set (SRCS Test_nested.pf)
list(APPEND SRCS Test_vector_Allocatable.pf)

if (SUPPORT_FOR_POINTERS_TO_FIXED_LENGTH_STRINGS)
  LIST (APPEND types character17)
endif ()

if (SUPPORT_FOR_POINTERS_TO_DEFERRED_LENGTH_STRINGS)
  LIST (APPEND types deferredLengthString)
endif ()

foreach (type ${types} )
  set (infile ${src}/Test_Vector.m4)
  set (pfunitfile Test_${type}Vector.pf)

  # Use relative path for outfile so that CMake correctly
  # detects the need to generate include files.

  add_custom_command (
    OUTPUT ${pfunitfile}
    COMMAND m4 -s -Dparam=${type} -Dcompiler=${CMAKE_Fortran_COMPILER_ID} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )

  list (APPEND SRCS ${bin}/${pfunitfile} )

  set (infile ${src}/Test_VectorIterator.m4)
  set (pfunitfile Test_${type}VectorIterator.pf)

  add_custom_command (
    OUTPUT ${pfunitfile}
    COMMAND m4 -s -Dparam=${type} -Dcompiler=${CMAKE_Fortran_COMPILER_ID} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )

  list (APPEND SRCS ${bin}/${pfunitfile} )

endforeach ()


if(CMAKE_Fortran_COMPILER_ID STREQUAL "Intel")
  if(CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 19)
    if(CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER 17)
      set_property(SOURCE Test_nested.F90 PROPERTY COMPILE_DEFINITIONS "__ifort_18")
    endif()
  endif()
endif()

add_pfunit_ctest (vector_tests
  TEST_SOURCES ${SRCS}
  LINK_LIBRARIES vectorSUT
  )

target_include_directories (vector_tests PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)
target_include_directories (vector_tests PRIVATE ${GFTL_SOURCE_DIR}/include)
add_dependencies (tests vector_tests)

=== tests/altSet/CMakeLists.txt ===
add_subdirectory(SUT)

set (src ${CMAKE_CURRENT_SOURCE_DIR})
set (bin ${CMAKE_CURRENT_BINARY_DIR})

set  (types
  integer
  real
  real64
  complex

  deferredLengthString
  unlimitedPolyPtr

  integer1d
  integer2d
  integer2d_fixedExtents

  integerAlloc
  integerPtr
  integer2dPtr

  Foo
  FooPtr
  FooPoly
  FooPolyPtr
  )

if (SUPPORTS_POINTERS_TO_FIXED_LENGTH_STRINGS)
  LIST (APPEND types character17)
endif ()

set(SRCS)

foreach (type ${types} )
  set (infile ${src}/Test_altSet.m4)
  set (pfunitfile Test_${type}altSet.pf)

  # Use relative path for outfile so that CMake correctly
  # detects the need to generate include files.

  add_custom_command (
    OUTPUT ${pfunitfile}
    COMMAND m4 -s -Dparam=${type} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )

  list (APPEND SRCS ${CMAKE_CURRENT_BINARY_DIR}/${pfunitfile} )

endforeach ()

add_pfunit_ctest (altSet_tests
  TEST_SOURCES ${SRCS}
  LINK_LIBRARIES altsetSUT
  )

target_include_directories (altSet_tests PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)
target_include_directories (altSet_tests PRIVATE ${GFTL_SOURCE_DIR}/include)
add_dependencies (tests altSet_tests)

=== tests/Map/SUT/CMakeLists.txt ===
set(src ${CMAKE_CURRENT_SOURCE_DIR})
set(bin ${CMAKE_CURRENT_BINARY_DIR})

set (instantiations
# vary value type
  "integer\;integer\;free"
  "integer\;real\;free"
  "integer\;logical\;free"
  "integer\;complex\;free"
  "integer\;deferredLengthString\;free"
  "integer\;Foo\;free"
  "integer\;FooPoly\;free"
  "integer\;integerAlloc\;free"
  "integer\;integerPtr\;free"
  "integer\;integer1d\;free"
  "integer\;integer2d_fixedExtents\;free"
  "integer\;integer2dPtr\;free"

# vary key type
  "real32\;integer\;free"
  "complex\;integer\;free"
  "deferredLengthString\;integer\;free"
  "Foo\;integer\;free"
  "integerAlloc\;integer\;free"
  "integerPtr\;integer\;free"
  "integer1d\;integer\;free"
  "integer2dPtr\;integer\;free"

  "deferredLengthString\;unlimitedPoly\;free"

# duplication combos
  "integerPtr\;integerPtr\;free"
  "integer1d\;integer1d\;free"
  "deferredLengthString\;deferredLengthString\;free"
)

set (SRCS)
set (altSRCS)
set (infile ${src}/Map.m4)
# Empty list - will append in loop below
foreach (instantiation ${instantiations})
  list (GET instantiation 0 key)
  list (GET instantiation 1 value)
  list (GET instantiation 2 format)

  if (format STREQUAL "free")
     set (outfile ${key}${value}Map.F90)
  else ()
     set (outfile ${key}${value}Map.F)
  endif ()

  add_custom_command (
    OUTPUT ${outfile}
    COMMAND m4 -s -Dkey=${key} -DALT -Dvalue=${value} -Dformat=${format} < ${infile} > ${outfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )

list (APPEND SRCS ${outfile} )

  if (format STREQUAL "free")
     set (outfile ${key}${value}altMap.F90)
  else ()
     set (outfile ${key}${value}altMap.F)
  endif ()

  add_custom_command (
    OUTPUT ${outfile}
    COMMAND m4 -s -Dkey=${key} -DALT=alt -Dvalue=${value} -Dformat=${format} < ${infile} > ${outfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )

list (APPEND altSRCS ${outfile} )

endforeach ()

list (APPEND SRCS MultiModule.F90)

add_library(mapSUT STATIC EXCLUDE_FROM_ALL ${SRCS} ${altSRCS})
target_include_directories (mapSUT PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories (mapSUT PRIVATE ${PFUNIT_TOP_DIR}/include)
target_link_libraries(mapSUT type_test_values shared gftl)

=== tests/Set/SUT/CMakeLists.txt ===
set (instantiations

  "integer\;free"
  "real\;free"
  "real32\;free"
  "real64\;free"
  "complex\;free"
  "complex64\;free"
  "complex128\;free"

  "deferredLengthString\;free"
#  "unlimitedPoly\;free"
  "unlimitedPolyPtr\;free"

  "integer1d\;free"
  "integer2d\;free"
  "integer2d_fixedExtents\;free"

  "integerAlloc\;free"
  "integerPtr\;free"
  "integer2dPtr\;free"

  "integer\;fixed"
 
  "Foo\;free"
  "FooPtr\;free"
  "FooPoly\;free"
  "FooPolyPtr\;free"
    
  "integer1d\;free"
  "integer2d\;free"
  "integer2d_fixedExtents\;free"
  )

if (SUPPORTS_POINTERS_TO_FIXED_LENGTH_STRINGS)
  list (APPEND instantiations "character17\;free")
endif ()

set (SRCS)
foreach (instantiation ${instantiations})
  list (GET instantiation 0 type)
  list (GET instantiation 1 format)

  set (infile ${CMAKE_CURRENT_SOURCE_DIR}/Set.m4)
  if (format STREQUAL "free")
     set (outfile ${type}Set.F90)
  else ()
     set (outfile ${type}Set.F)
  endif ()


  # Use relative path for outfile so that CMake correctly
  # detects the need to generate include files.

  add_custom_command (
    OUTPUT ${outfile}
    DEPENDS ${infile}
    COMMAND m4 -Dtype=${type} -Dformat=${format} ${infile} > ${outfile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    )

  list (APPEND SRCS ${outfile})

endforeach ()

list (APPEND SRCS MultiModule.F90)

add_library(setSUT STATIC EXCLUDE_FROM_ALL ${SRCS})
target_include_directories (setSUT PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories (setSUT PRIVATE ${PFUNIT_TOP_DIR}/include)
target_link_libraries(setSUT type_test_values shared gftl)

=== tests/Vector/SUT/CMakeLists.txt ===
set(src ${CMAKE_CURRENT_SOURCE_DIR})
set(bin ${CMAKE_CURRENT_BINARY_DIR})


set (instantiations
  "integer\;free"
  "real\;free"
  "real32\;free"
  "real64\;free"
  "complex\;free"
  "complex64\;free"
  "complex128\;free"
  "logical\;free"
  "deferredLengthString\;free"
  "unlimitedPoly\;free"
  "unlimitedPolyPtr\;free"

  "integer1d\;free"
  "integer2d\;free"
  "integer2d_fixedExtents\;free"

  "integerAlloc\;free"
  "integerPtr\;free"
  "integer2dPtr\;free"

  "integer\;fixed"
 
  "Foo\;free"
  "FooPtr\;free"
  "FooPoly\;free"
  "FooPolyPtr\;free"
    
  )

if (SUPPORT_FOR_POINTERS_TO_FIXED_LENGTH_STRINGS)
  LIST (APPEND instantiations "character17\;free")
endif ()

set (SRCS)
set (infile ${src}/Vector.m4)
# Empty list - will append in loop below
foreach (instantiation ${instantiations})
  list (GET instantiation 0 type)
  list (GET instantiation 1 format)

  if (format STREQUAL "free")
     set (outfile ${type}Vector.F90)
  else ()
     set (outfile ${type}Vector.F)
  endif ()

  # Use relative path for outfile so that CMake correctly
  # detects the need to generate include files.

  add_custom_command (
    OUTPUT ${outfile}
    COMMAND m4 -s -Dtype=${type} -Dformat=${format} < ${infile} > ${outfile}
    WORKING_DIRECTORY ${bin}
    DEPENDS ${infile}
    )
  
  list (APPEND SRCS ${outfile} )

endforeach ()

list (APPEND SRCS MultiModule.F90)

add_library(vectorSUT EXCLUDE_FROM_ALL STATIC ${SRCS})
target_include_directories (vectorSUT PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories (vectorSUT PRIVATE ${PFUNIT_TOP_DIR}/include)
target_link_libraries(vectorSUT type_test_values shared gftl)

=== tests/altSet/SUT/CMakeLists.txt ===
include_directories (${GFTL_BINARY_DIR}/tests/shared)

set (instantiations

  "integer\;free"
  "real\;free"
  "real32\;free"
  "real64\;free"
  "complex\;free"
  "complex64\;free"
  "complex128\;free"

  "deferredLengthString\;free"
  "unlimitedPolyPtr\;free"

  "integer1d\;free"
  "integer2d\;free"
  "integer2d_fixedExtents\;free"

  "integerAlloc\;free"
  "integerPtr\;free"
  "integer2dPtr\;free"

  "integer\;fixed"
 
  "Foo\;free"
  "FooPtr\;free"
  "FooPoly\;free"
  "FooPolyPtr\;free"
    
  "integer1d\;free"
  "integer2d\;free"
  "integer2d_fixedExtents\;free"
  )

if (SUPPORTS_POINTERS_TO_FIXED_LENGTH_STRINGS)
  list (APPEND instantiations "character17\;free")
endif ()

set (SRCS)
foreach (instantiation ${instantiations})
  list (GET instantiation 0 type)
  list (GET instantiation 1 format)

  set (infile ${CMAKE_CURRENT_SOURCE_DIR}/altSet.m4)
  if (format STREQUAL "free")
     set (outfile ${type}altSet.F90)
  else ()
     set (outfile ${type}altSet.F)
  endif ()


  # Use relative path for outfile so that CMake correctly
  # detects the need to generate include files.

  add_custom_command (
    OUTPUT ${outfile}
    DEPENDS ${infile}
    COMMAND m4 -Dtype=${type} -Dformat=${format} ${infile} > ${outfile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    )

  list (APPEND SRCS ${outfile})

endforeach ()

list (APPEND SRCS MultiModule.F90)

add_library(altsetSUT STATIC EXCLUDE_FROM_ALL ${SRCS})
target_include_directories (altsetSUT PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories (altsetSUT PRIVATE ${PFUNIT_TOP_DIR}/include)
target_link_libraries(altsetSUT type_test_values shared gftl)

=== debian/changelog ===
gftl (1.2.5-2) unstable; urgency=low

  * Make the build reproducible (Closes: #963602)

 -- Ole Streicher <olebole@debian.org>  Wed, 24 Jun 2020 11:55:24 +0200

gftl (1.2.5-1) unstable; urgency=low

  * Initial release. Closes: #961670

 -- Ole Streicher <olebole@debian.org>  Tue, 26 May 2020 09:47:26 +0200

=== debian/control ===
Source: gftl
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (=12),
               gfortran,
               m4
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/gftl
Vcs-Git: https://salsa.debian.org/science-team/gftl.git
Homepage: https://github.com/Goddard-Fortran-Ecosystem/gFTL
Rules-Requires-Root: no

Package: gftl-dev
Architecture: all
Depends: ${misc:Depends}
Description: Containers and iterators for Fortran
 gFTL provides a mechanism to easily create robust containers and
 associated iterators which can be used within Fortran
 applications. The primary methods are intended to be as close to
 their C++ STL analogs as possible. These containers are a powerful
 productivity multiplier for certain types of software development,
 and hope that others find them to be just as useful.

## gftl 1.3.0%2Bis-really

=== tests/Set/CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
   add_custom_command (
     OUTPUT ${pfunitfile}
-    COMMAND m4 -s -Dparam=${type} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
+    COMMAND ${M4} -s -Dparam=${type} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
     WORKING_DIRECTORY ${bin}
     DEPENDS ${infile}
     )

## gftl 1.3.0%2Bis-really-1.2.7

=== debian/changelog ===
gftl (1.3.0+is-really-1.2.7-2) unstable; urgency=medium

  * Team Upload
  * Fix Team name
  * Add debian/salsa-ci.yml
  * Fix FTBFS with CMake 4 (Closes: #1112951)
  * Update standards version to 4.7.2

  [ Debian Janitor ]
  * Apply multi-arch hints. + gftl-dev: Add Multi-Arch: foreign.
  * Set upstream metadata fields

 -- Alexandre Detiste <tchet@debian.org>  Sun, 12 Oct 2025 11:53:19 +0200

gftl (1.3.0+is-really-1.2.7-1) unstable; urgency=medium

  * Revert upstream to 1.2.7. Closes: #978352
  * Revert patch to 1.2.7 version

 -- Ole Streicher <olebole@debian.org>  Tue, 19 Jan 2021 12:16:52 +0100

gftl (1.3.0-1) unstable; urgency=medium

  * New upstream version 1.3.0
  * Rediff patches

 -- Ole Streicher <olebole@debian.org>  Tue, 08 Dec 2020 17:41:57 +0100

gftl (1.2.7-1) unstable; urgency=low

  * New upstream version 1.2.7. Rediff patches
  * Push Standards-Version to 13

 -- Ole Streicher <olebole@debian.org>  Tue, 01 Sep 2020 08:35:59 +0200

## gftl 1.3.0+is-really

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 endif (COMMAND cmake_policy)
 
 project (GFTL
-  VERSION 1.2.5
+  VERSION 1.2.7
   LANGUAGES Fortran)
 
 if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
@@ -13,6 +13,11 @@
   message("   Override with -DCMAKE_INSTALL_PREFIX=<path>.")
 endif ()
 
+# For BSD systems use GNU m4
+find_program( M4 NAMES "gm4" "m4")
+if( NOT M4 )
+  message( SEND_ERROR "m4 program not found" )
+endif()
 
 add_subdirectory (include)
 add_subdirectory (examples)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Intel")
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -assume realloc_lhs")
endif()
#add_subdirectory(Map)
#add_subdirectory(Vector)
##add_subdirectory(Tracer)

=== include/CMakeLists.txt ===
add_library (gftl INTERFACE)
set (dest "GFTL-${GFTL_VERSION_MAJOR}.${GFTL_VERSION_MINOR}")
target_include_directories (gftl INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}> # for headers when building
  $<INSTALL_INTERFACE:${dest}/include> # for client in install mode
)

add_subdirectory (templates)
add_subdirectory (types)


add_custom_command(
  OUTPUT GFTL_incs_generated_successfully
  DEPENDS gftl
  COMMAND touch fidl_generated_successfully
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  )

add_custom_target (force-generation-of-includes ALL)
add_dependencies (force-generation-of-includes gftl)

install (TARGETS gftl EXPORT GFTL DESTINATION "${dest}/include")
install (EXPORT GFTL DESTINATION "${dest}/cmake")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 add_subdirectory (Set)
 add_subdirectory (altSet)
 
-# Need to exapnd intrinsic template for various types with m4
+# Need to expand intrinsic template for various types with m4
 add_subdirectory(include)

=== examples/Map/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

include_directories("$ENV{FTL}/include")
add_executable(CIKey.x CaseInsensitiveKey.F90)
add_executable(StringPoly.x StringPoly.F90)
add_executable(StringArray.x StringArray.F90)
add_executable(mapmap.x Mapsmap.F90)

=== examples/Tracer/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

include_directories("$ENV{FTL}/include")
link_directories("$ENV{MODELE}/modelEMaster/model/shared")
link_directories("$ENV{MODELE}/modelEMaster/model/MPI_Support")
link_directories("$ENV{MODELE}/modelEMaster/model/tracers")
link_directories("$ENV{MODELE}/modelEMaster/model/dd2d")
link_directories("$ENV{MODELE}/modelEMaster/model/profiler")
link_directories("$ENV{NETCDFHOME}/lib")
link_directories("$ENV{PNETCDFHOME}/lib")
#link_directories("/opt/local/lib")
include_directories("$ENV{MODELE}/modelEMaster/model/mod")

set(srcs AbstractValue.F90)
list(APPEND srcs Values.F90)
list(APPEND srcs AttributeMap.F90)
list(APPEND srcs Tracer.F90)
list(APPEND srcs TracerBundle.F90)

set(SOURCES ${srcs})
add_library(mytracer STATIC ${SOURCES})
add_executable(values.x ${SOURCES} TestValues.F90)
add_executable(vType.x ${SOURCES} TestValueType.F90)
add_executable(attrMap.x ${SOURCES} TestAttributeMap.F90)
add_executable(aTracer.x ${SOURCES} TestTracer.F90)
add_executable(aBundle.x ${SOURCES} TestTracerBundle.F90)
target_link_libraries(values.x tracers shared MPI_Support dd2d profiler netcdf)
target_link_libraries(vType.x tracers shared MPI_Support dd2d profiler netcdf)
target_link_libraries(attrMap.x tracers shared MPI_Support dd2d profiler netcdf )
target_link_libraries(aTracer.x tracers shared MPI_Support dd2d profiler netcdf )
target_link_libraries(aBundle.x tracers shared MPI_Support dd2d profiler netcdf)

=== examples/Vector/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

include_directories("$ENV{FTL}/include")
#add_executable(VecIntAndReal.x EXCLUDE_FROM_ALL VecIntAndReal.F90)
#add_executable(VecMyType.x EXCLUDE_FROM_ALL VecMyType.F90)
#add_executable(VecMyPolyPtr.x EXCLUDE_FROM_ALL VecMyPolyPtr.F90)
add_executable(VecIntAndReal.x VecIntAndReal.F90)
add_executable(VecMyType.x VecMyType.F90)
add_executable(VecMyPolyPtr.x VecMyPolyPtr.F90)

=== include/templates/CMakeLists.txt ===
--- 
+++ 
@@ -17,11 +17,6 @@
 # Empty list - will append in loop below
 set(generated_incs)
 
-find_program( m4_found "m4" )
-if( NOT m4_found )
-  message( SEND_ERROR "m4 program not found" )
-endif()
-
 foreach( macro_file ${macro_files} )
   foreach( param ${template_params} )
     set( infile ${src}/${macro_file}.m4 )
@@ -30,7 +25,7 @@
 
     add_custom_command (
       OUTPUT ${outfile}
-      COMMAND m4 -s -Dparam=${param} -I${src}/../templates < ${infile} > ${outfile}
+      COMMAND ${M4} -s -Dparam=${param} -I${src}/../templates < ${infile} > ${outfile}
       WORKING_DIRECTORY ${bin}
       DEPENDS ${infile}
       )

=== include/types/CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
 
     add_custom_command (
       OUTPUT ${outfile}
-      COMMAND m4 -s -Dparam=${param} -I${src}/../templates < ${infile} > ${outfile}
+      COMMAND ${M4} -s -Dparam=${param} -I${src}/../templates < ${infile} > ${outfile}
       WORKING_DIRECTORY ${bin}
       DEPENDS ${infile}
       )
@@ -66,5 +66,6 @@
 install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/ DESTINATION "${dest}/include/types"
   FILES_MATCHING PATTERN "*.inc"
   PATTERN CMakeFiles EXCLUDE
+  PATTERN "*Foo*" EXCLUDE
   )

=== tests/Map/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
   add_custom_command (
     OUTPUT ${pfunitfile}
-    COMMAND m4 -s -DKEY=${key} -DVALUE=${value} -DALT= -Dformat=${format} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
+    COMMAND ${M4} -s -DKEY=${key} -DVALUE=${value} -DALT= -Dformat=${format} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
     WORKING_DIRECTORY ${bin}
     DEPENDS ${infile}
     )
@@ -70,7 +70,7 @@
 
   add_custom_command (
     OUTPUT ${pfunitfile}
-    COMMAND m4 -s -DKEY=${key} -DVALUE=${value} -DALT=alt -Dformat=${format} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
+    COMMAND ${M4} -s -DKEY=${key} -DVALUE=${value} -DALT=alt -Dformat=${format} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
     WORKING_DIRECTORY ${bin}
     DEPENDS ${infile}
     )

=== tests/Vector/CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,7 @@
 
   add_custom_command (
     OUTPUT ${pfunitfile}
-    COMMAND m4 -s -Dparam=${type} -Dcompiler=${CMAKE_Fortran_COMPILER_ID} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
+    COMMAND ${M4} -s -Dparam=${type} -Dcompiler=${CMAKE_Fortran_COMPILER_ID} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
     WORKING_DIRECTORY ${bin}
     DEPENDS ${infile}
     )
@@ -61,7 +61,7 @@
 
   add_custom_command (
     OUTPUT ${pfunitfile}
-    COMMAND m4 -s -Dparam=${type} -Dcompiler=${CMAKE_Fortran_COMPILER_ID} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
+    COMMAND ${M4} -s -Dparam=${type} -Dcompiler=${CMAKE_Fortran_COMPILER_ID} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
     WORKING_DIRECTORY ${bin}
     DEPENDS ${infile}
     )

=== tests/altSet/CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,7 @@
 
   add_custom_command (
     OUTPUT ${pfunitfile}
-    COMMAND m4 -s -Dparam=${type} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
+    COMMAND ${M4} -s -Dparam=${type} -I${GFTL_SOURCE_DIR}/include/templates < ${infile} > ${pfunitfile}
     WORKING_DIRECTORY ${bin}
     DEPENDS ${infile}
     )

## gftl 1.3.0+is-really-1.2.7

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,21 @@
 Source: gftl
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ole Streicher <olebole@debian.org>
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (=12),
+               debhelper-compat (=13),
                gfortran,
                m4
-Standards-Version: 4.5.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/science-team/gftl
 Vcs-Git: https://salsa.debian.org/science-team/gftl.git
 Homepage: https://github.com/Goddard-Fortran-Ecosystem/gFTL
-Rules-Requires-Root: no
 
 Package: gftl-dev
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Containers and iterators for Fortran
  gFTL provides a mechanism to easily create robust containers and
  associated iterators which can be used within Fortran

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gftl-$1\.tar\.gz/ \
  https://github.com/Goddard-Fortran-Ecosystem/gFTL/tags .*/v?(\d\S*)\.tar\.gz
